Summary: Multicore Application Runtime System
Name: mars
Version: 1.1.0
Release: 1
License: MIT plus and MIT
Group: System Environment/Libraries
URL: ftp://ftp.infradead.org/pub/Sony-PS3/mars/
Source0: ftp://ftp.infradead.org/pub/Sony-PS3/mars/%{version}/mars-src-%{version}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

Requires: libspe2, numactl
BuildRequires: ppu-gcc, spu-gcc, libspe2-devel, numactl-devel, doxygen, librsvg2

%define __os_install_post	/usr/lib/rpm/brp-compress

%description
MARS (Multicore Application Runtime System) is a set of libraries that
provides an API to easily manage and create user programs that will be
scheduled to run on various microprocessing units of a multicore
environment.

%package devel
Summary: Multicore Application Runtime System
Group: Development/Libraries
Requires: %{name} = %{version}, libspe2-devel

%description devel
Headers and static libraries for MARS (Multicore Application Runtime
System).

%package doc
Summary: Multicore Application Runtime System
Group: Documentation
Requires: %{name} = %{version}

%description doc
Documentation of MARS (Multicore Application Runtime System).

%package samples
Summary: Multicore Application Runtime System
Group: Development/Libraries
Requires: %{name} = %{version}

%description samples
Samples of MARS (Multicore Application Runtime System).

%prep
%setup -q -n mars-src-%{version}

%build

PPU_CC='ppu-gcc'
%ifarch ppc
PPU_CFLAGS='-m32'
%endif
%ifarch ppc64
PPU_CFLAGS='-m64'
%endif

tmp_install_dir="`pwd`/install_dir"

%define mars_configure_opts \\\
	PPU_CC="$PPU_CC" PPU_CFLAGS="$PPU_CFLAGS -g -O2" \\\
	PPU_CPPFLAGS="-I$tmp_install_dir%{_prefix}/include" \\\
	PPU_LDFLAGS="-Wl,-L$tmp_install_dir%{_libdir}" \\\
	SPU_CPPFLAGS="-I$tmp_install_dir%{_prefix}/spu/include" \\\
	SPU_LDFLAGS="-Wl,-L$tmp_install_dir%{_prefix}/spu/lib" \\\
	--host=%{_host} \\\
	--build=%{_build} \\\
	--prefix=%{_prefix} \\\
	--libdir=%{_libdir} \\\
	--with-mars-platform=cell

cd core
./configure %{mars_configure_opts}
make
make DESTDIR="$tmp_install_dir" install
cd ..

cd task
./configure %{mars_configure_opts}
make
cd ..

cd doxygen
make VERSION=%{version}
cd ..

cd samples
make VERSION=%{version} dist
cd ..

%install
rm -rf %{buildroot}

cd core
make install DESTDIR=%{buildroot}
cd ..

cd task
make install DESTDIR=%{buildroot}
cd ..

mkdir -p %{buildroot}%{_docdir}/%{name}-%{version}
cp -a doxygen/mars-docs-%{version} %{buildroot}%{_docdir}/%{name}-%{version}/mars-doc
cp core/{README,COPYING} %{buildroot}%{_docdir}/%{name}-%{version}

mkdir -p %{buildroot}%{_datadir}/%{name}-%{version}
tar zxf samples/mars-samples-%{version}.tar.gz -C %{buildroot}%{_datadir}/%{name}-%{version}
mv %{buildroot}%{_datadir}/%{name}-%{version}/mars-samples-%{version} \
   %{buildroot}%{_datadir}/%{name}-%{version}/samples

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%{_libdir}/*.so*

%files devel
%defattr(-,root,root,-)
%{_libdir}/*.a
%{_libdir}/*.la
%{_includedir}/*
%{_prefix}/spu/*

%files doc
%defattr(-,root,root,-)
%{_docdir}/*

%files samples
%defattr(-,root,root,-)
%{_datadir}/%{name}-%{version}/samples/*

%changelog
* Thu Dec 11 2008 Kazunori Asayama <asayama@sm.sony.co.jp> - 1.1.0-1
- Add task module to the package.

* Mon Oct 27 2008 Kazunori Asayama <asayama@sm.sony.co.jp> - 1.0.1-1
- Initial build.
