#!/bin/sh
#
# Copyright 2008 Sony Corporation
#
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
# Usage: desc.sh <TEST_ID>
#

scripts_dir="`dirname $0`"

. "$scripts_dir"/run_functions

list="$scripts_dir/tests.csv"

for t in "$@"
do
    id="`echo $t|sed -e 's,_,,g'`"
    awk '
BEGIN {
	FS=";"
}
$4 == "'$id'" {
	printf("\n")

	printf("Class: %s\n", $3)
	printf("Id: %s\n", $4)
	printf("Processor: %s\n", $7)
	printf("Function: %s\n", $8);

	summary = $9
	sub(/^"/, "", summary)
	sub(/"[[:space:]]*$/, "", summary)
	printf("Summary: %s\n", summary);

	desc = $0
	sub(/^[^;]*;[^;]*;[^;]*;[^;]*;[^;]*;[^;]*;[^;]*;[^;]*;[^;]*;/, "", desc)
	sub(/^"/, "", desc)
	sub(/"[[:space:]]*$/, "", desc)
	gsub(/\f/, "\n", desc)

	printf("Description:\n")
	print desc | "fold -c68 -s | sed -e \"s,^,        ,\""
}
' "$list"
done
